summaryrefslogtreecommitdiffstats
path: root/academic/wise/wise.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'academic/wise/wise.SlackBuild')
-rw-r--r--academic/wise/wise.SlackBuild131
1 files changed, 131 insertions, 0 deletions
diff --git a/academic/wise/wise.SlackBuild b/academic/wise/wise.SlackBuild
new file mode 100644
index 0000000000..84230832be
--- /dev/null
+++ b/academic/wise/wise.SlackBuild
@@ -0,0 +1,131 @@
+#!/bin/bash
+
+# Slackware build script for <wise>
+
+# Copyright 2023 Petar Petrov, slackalaxy@gmail.com
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=wise
+VERSION=${VERSION:-2.4.1}
+BUILD=${BUILD:-2}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+else
+ SLKCFLAGS="-O2"
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/${PRGNAM}_${VERSION}.orig.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+patch -p1 -i $CWD/patches/01_welcome-csh.patch
+patch -p1 -i $CWD/patches/02_isnumber.patch
+patch -p1 -i $CWD/patches/03_doc-nodycache.patch
+patch -p1 -i $CWD/patches/04_wise2-pdflatex-update.patch
+patch -p1 -i $CWD/patches/05_glib2.patch
+patch -p1 -i $CWD/patches/06_getline.patch
+patch -p1 -i $CWD/patches/07_ld--as-needed.patch
+patch -p1 -i $CWD/patches/08_mayhem.patch
+patch -p1 -i $CWD/patches/09_dnal-add-return-statement.patch
+patch -p1 -i $CWD/patches/10_fix_path_to_data_files.patch
+patch -p1 -i $CWD/patches/11_consistent_manual_dates.patch
+patch -p1 -i $CWD/patches/spelling.patch
+patch -p1 -i $CWD/patches/cross.patch
+
+# This prevents some weird build breaks. Thanks to Urchlay. His explanation:
+#
+# The .c files that are in the tarball, were already built from the .dy
+# files. However, some of them get patched, e.g. wisefile.c and wisefile.dy
+# both have a modification time of the current time/date, which is why make
+# thinks it needs to rebuild the wisefile.c. When make is run, it looks at
+# the timestamps and decided wisefile.c is older than wisefile.dy (which it
+# is, ever so slightly, assuming the filesystem's timestamp resolution is
+# fine enough). What the solution does is force the timestamp on all the
+# .dy files to be older than the generated .c files, so make won't think it
+# needs to run dyc to generate the .c files.
+find src -name \*.dy -print0 | xargs -0 touch -d '2000-01-01'
+
+cd src
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+make all
+
+mkdir -p $PKG/usr/bin
+mkdir -p $PKG/usr/share/$PRGNAM
+
+cd bin
+for i in * ; do
+ install -m 755 $i $PKG/usr/bin/$i
+done
+
+cd ../..
+cp -a test_data wisecfg/* $PKG/usr/share/$PRGNAM
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README docs/{*.tex,*.eps,papers} \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE